﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace Sample1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void chart_ZoomChanged(object sender, ZoomChangedEventArgs e)
        {
            
        }
    }

    public class NumericalAxisExt : NumericalAxis
    {
        List<double> yValues = new List<double>();

        protected override void CalculateVisibleRange(Size avalableSize)
        {
            base.CalculateVisibleRange(avalableSize);

            yValues.Clear();

            SfChart chart = typeof(ChartAxis).GetProperty("Area", System.Reflection.BindingFlags.NonPublic |
                System.Reflection.BindingFlags.Instance).GetValue(this) as SfChart;

            List<double> actualyValues = typeof(XyDataSeries).GetProperty("YValues",
                System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance).GetValue(chart.Series[0]) as List<double>;

            var range = chart.PrimaryAxis.VisibleRange;

            if (actualyValues != null && actualyValues.Count > (int)range.Start && actualyValues.Count > (int)range.End)
            {
                for (int i = (int)range.Start; i <= range.End; i++)
                {
                    yValues.Add(actualyValues[i]);
                }

                if (yValues.Count > 0)
                {
                    double min = yValues.Min();
                    double max = yValues.Max();

                    VisibleRange = new DoubleRange(min, max);
                }
            }
           
           var visibleInterval = CalculateNiceInterval(VisibleRange, avalableSize);

           typeof(ChartAxis).GetProperty("VisibleInterval", System.Reflection.BindingFlags.NonPublic |
                System.Reflection.BindingFlags.Instance).SetValue(this, visibleInterval);
        }
    }

    public class Model
    {
        public string XValue { get; set; }
        public double YValue { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            GenerateData();           
        }

        public void GenerateData()
        {
            Data = new ObservableCollection<Model>();
            Random rd = new Random();

            for (int i = 0; i < 500; i++)
            {
                Data.Add(new Model()
                {
                    XValue = "",
                    YValue = rd.Next(0, 50)
                });
            }

            for (int i = 0; i < 500; i++)
            {
                Data.Add(new Model()
                {
                    XValue = "",
                    YValue = rd.Next(0, 4000)
                });
            }

            for (int i = 0; i < 4000; i++)
            {
                Data.Add(new Model()
                {
                    XValue = "",
                    YValue = rd.Next(0,50)
                });
            }
        }

        private ObservableCollection<Model> data;

        public ObservableCollection<Model> Data
        {
            get { return data; }
            set { data = value;  }
        }

        
       
    }
    
}
